org.cpsolver.studentsct.weights

## Class PriorityStudentWeights

- java.lang.Object
- - org.cpsolver.studentsct.weights.PriorityStudentWeights

- All Implemented Interfaces:
    SolutionComparator<Request,Enrollment>, StudentWeights
  Direct Known Subclasses:
    EqualStudentWeights

      public class PriorityStudentWeights
      extends Object
      implements StudentWeights

  New weighting model. It tries to obey the following principles:
  - Total student weight is between zero and one (one means student got the best schedule)
  - Weight of the given priority course is higher than sum of the remaining weights the student can get
  - First alternative is better than the following course
  - Second alternative is better than the second following course
  - Distance conflicts are considered secondary (priorities should be maximized first)
  - If alternative sections are otherwise equal, use the better balanced one
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.cpsolver.studentsct.weights.StudentWeights

      `StudentWeights.Implementation`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `iAdditiveWeights`
    `protected double` | `iAlternativeRequestFactor`
    `protected double` | `iBalancingFactor`
    `protected double` | `iCriticalBoost`
    `protected double` | `iDistanceConflict`
    `protected double` | `iFirstAlternativeFactor`
    `protected double` | `iGroupBestRatio`
    `protected double` | `iGroupFactor`
    `protected double` | `iGroupFillRatio`
    `protected boolean` | `iImprovedBound`
    `protected boolean` | `iLeftoverSpread`
    `protected boolean` | `iMaximizeAssignment`
    `protected boolean` | `iMPP`
    `protected double` | `iNoTimeFactor`
    `protected double` | `iOnlineFactor`
    `protected double` | `iPastFactor`
    `protected double` | `iPerturbationFactor`
    `protected boolean` | `iPreciseComparison`
    `protected double` | `iPriorityFactor`
    `protected double` | `iPriortyBoost`
    `protected double` | `iProjectedStudentWeight`
    `protected double[]` | `iQalityWeights`
    `protected double` | `iReservationNotFollowedFactor`
    `protected double` | `iSameChoiceWeight`
    `protected double` | `iSameConfigWeight`
    `protected double` | `iSameTimeWeight`
    `protected double` | `iSecondAlternativeFactor`
    `protected double` | `iSelectionFactor`
    `protected double` | `iShortDistanceConflict`
    `protected double` | `iTimeOverlapFactor`
    `protected double` | `iTimeOverlapMaxLimit`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PriorityStudentWeights(DataProperties config)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double` | `computeBound(double base, Request request)`
    `protected double` | `getBaseWeight(Assignment<Request,Enrollment> assignment, Enrollment enrollment)`
    `double` | `getBoostedWeight(Request request)`
    `double` | `getBound(Request request)` Return lower bound for the given request
    `double` | `getCachedWeight(Request request)`
    `protected double` | `getDifference(Enrollment enrollment)` Return how much the given enrollment is different from the initial enrollment
    `double` | `getDistanceConflictWeight(Assignment<Request,Enrollment> assignment, DistanceConflict.Conflict c)` Return weight of a distance conflict
    `double` | `getSelection(Enrollment enrollment)` Return how much the given enrollment is different from the selection (if any)
    `double` | `getStudentQualityConflictWeight(Assignment<Request,Enrollment> assignment, Enrollment enrollment, StudentQuality.Conflict conflict)` Return weight of a student quality conflict
    `double` | `getTimeOverlapConflictWeight(Assignment<Request,Enrollment> assignment, Enrollment e, TimeOverlapsCounter.Conflict c)` Return weight of a time overlapping conflict
    `double` | `getWeight(Assignment<Request,Enrollment> assignment, Enrollment enrollment)` Return base weight of the given enrollment
    `double` | `getWeight(Assignment<Request,Enrollment> assignment, Enrollment enrollment, Set<DistanceConflict.Conflict> distanceConflicts, Set<TimeOverlapsCounter.Conflict> timeOverlappingConflicts)` Return weight of the given enrollment
    `double` | `getWeight(Assignment<Request,Enrollment> assignment, Enrollment enrollment, Set<StudentQuality.Conflict> qualityConflicts)` Return weight of the given enrollment
    `double` | `getWeight(Request request)`
    `double` | `getWeightAdditive(Assignment<Request,Enrollment> assignment, Enrollment enrollment)`
    `double` | `getWeightMultiplicative(Assignment<Request,Enrollment> assignment, Enrollment enrollment)`
    `boolean` | `isBetterThanBestSolution(Solution<Request,Enrollment> currentSolution)` Compares two solutions.
    `boolean` | `isFreeTimeAllowOverlaps()` Return true if free time requests allow overlaps
    `static void` | `main(String[] args)` Test case -- run to see the weights for a few courses
    `protected double` | `round(double value)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iPriorityFactor

          protected double iPriorityFactor

    - #### iFirstAlternativeFactor

          protected double iFirstAlternativeFactor

    - #### iSecondAlternativeFactor

          protected double iSecondAlternativeFactor

    - #### iDistanceConflict

          protected double iDistanceConflict

    - #### iShortDistanceConflict

          protected double iShortDistanceConflict

    - #### iTimeOverlapFactor

          protected double iTimeOverlapFactor

    - #### iTimeOverlapMaxLimit

          protected double iTimeOverlapMaxLimit

    - #### iLeftoverSpread

          protected boolean iLeftoverSpread

    - #### iBalancingFactor

          protected double iBalancingFactor

    - #### iNoTimeFactor

          protected double iNoTimeFactor

    - #### iOnlineFactor

          protected double iOnlineFactor

    - #### iPastFactor

          protected double iPastFactor

    - #### iReservationNotFollowedFactor

          protected double iReservationNotFollowedFactor

    - #### iAlternativeRequestFactor

          protected double iAlternativeRequestFactor

    - #### iProjectedStudentWeight

          protected double iProjectedStudentWeight

    - #### iMPP

          protected boolean iMPP

    - #### iPerturbationFactor

          protected double iPerturbationFactor

    - #### iSelectionFactor

          protected double iSelectionFactor

    - #### iSameChoiceWeight

          protected double iSameChoiceWeight

    - #### iSameTimeWeight

          protected double iSameTimeWeight

    - #### iSameConfigWeight

          protected double iSameConfigWeight

    - #### iGroupFactor

          protected double iGroupFactor

    - #### iGroupBestRatio

          protected double iGroupBestRatio

    - #### iGroupFillRatio

          protected double iGroupFillRatio

    - #### iAdditiveWeights

          protected boolean iAdditiveWeights

    - #### iMaximizeAssignment

          protected boolean iMaximizeAssignment

    - #### iPreciseComparison

          protected boolean iPreciseComparison

    - #### iQalityWeights

          protected double[] iQalityWeights

    - #### iImprovedBound

          protected boolean iImprovedBound

    - #### iCriticalBoost

          protected double iCriticalBoost

    - #### iPriortyBoost

          protected double iPriortyBoost

  - ### Constructor Detail

    - #### PriorityStudentWeights

          public PriorityStudentWeights(DataProperties config)

  - ### Method Detail

    - #### getWeight

          public double getWeight(Request request)

    - #### getBoostedWeight

          public double getBoostedWeight(Request request)

    - #### getCachedWeight

          public double getCachedWeight(Request request)

    - #### getDifference

          protected double getDifference(Enrollment enrollment)

      Return how much the given enrollment is different from the initial enrollment
      Parameters:
        `enrollment` - given enrollment
      Returns:
        0.0 when all the sections are the same, 1.0 when all the section are different (including different times)

    - #### getSelection

          public double getSelection(Enrollment enrollment)

      Return how much the given enrollment is different from the selection (if any)
      Parameters:
        `enrollment` - given enrollment
      Returns:
        0.0 when all the sections are the same, 1.0 when all the section are different (including different times)

    - #### getBound

          public double getBound(Request request)

      Description copied from interface: `StudentWeights`
      Return lower bound for the given request
      Specified by:
        `getBound` in interface `StudentWeights`
      Parameters:
        `request` - given request
      Returns:
        weight of the best value

    - #### computeBound

          protected double computeBound(double base,
                                        Request request)

    - #### round

          protected double round(double value)

    - #### getBaseWeight

          protected double getBaseWeight(Assignment<Request,Enrollment> assignment,
                                         Enrollment enrollment)

    - #### getWeight

          public double getWeight(Assignment<Request,Enrollment> assignment,
                                  Enrollment enrollment)

      Description copied from interface: `StudentWeights`
      Return base weight of the given enrollment
      Specified by:
        `getWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `enrollment` - given enrollment
      Returns:
        weight (higher weight means better value)

    - #### getWeightMultiplicative

          public double getWeightMultiplicative(Assignment<Request,Enrollment> assignment,
                                                Enrollment enrollment)

    - #### getWeightAdditive

          public double getWeightAdditive(Assignment<Request,Enrollment> assignment,
                                          Enrollment enrollment)

    - #### getDistanceConflictWeight

          public double getDistanceConflictWeight(Assignment<Request,Enrollment> assignment,
                                                  DistanceConflict.Conflict c)

      Description copied from interface: `StudentWeights`
      Return weight of a distance conflict
      Specified by:
        `getDistanceConflictWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `c` - distance conflict
      Returns:
        weight of the conflict

    - #### getTimeOverlapConflictWeight

          public double getTimeOverlapConflictWeight(Assignment<Request,Enrollment> assignment,
                                                     Enrollment e,
                                                     TimeOverlapsCounter.Conflict c)

      Description copied from interface: `StudentWeights`
      Return weight of a time overlapping conflict
      Specified by:
        `getTimeOverlapConflictWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `e` - enrollment in question
        `c` - time overlapping conflict
      Returns:
        weight of the conflict

    - #### getWeight

          public double getWeight(Assignment<Request,Enrollment> assignment,
                                  Enrollment enrollment,
                                  Set<DistanceConflict.Conflict> distanceConflicts,
                                  Set<TimeOverlapsCounter.Conflict> timeOverlappingConflicts)

      Description copied from interface: `StudentWeights`
      Return weight of the given enrollment
      Specified by:
        `getWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `enrollment` - given enrollment
        `distanceConflicts` - distance conflicts
        `timeOverlappingConflicts` - time overlapping conflicts
      Returns:
        weight (higher weight means better value)

    - #### isBetterThanBestSolution

          public boolean isBetterThanBestSolution(Solution<Request,Enrollment> currentSolution)

      Description copied from interface: `SolutionComparator`
      Compares two solutions. Returns true if the given solution is better than its best ever found solution (see `Solution.saveBest()` and `Solution.restoreBest()`).
      Specified by:
        `isBetterThanBestSolution` in interface `SolutionComparator<Request,Enrollment>`
      Parameters:
        `currentSolution` - given solution
      Returns:
        true if the given solution is better than the best ever found solution

    - #### isFreeTimeAllowOverlaps

          public boolean isFreeTimeAllowOverlaps()

      Description copied from interface: `StudentWeights`
      Return true if free time requests allow overlaps
      Specified by:
        `isFreeTimeAllowOverlaps` in interface `StudentWeights`
      Returns:
        true if free time overlaps are allowed, but the overlapping time is minimized

    - #### main

          public static void main(String[] args)

      Test case -- run to see the weights for a few courses
      Parameters:
        `args` - program arguments

    - #### getWeight

          public double getWeight(Assignment<Request,Enrollment> assignment,
                                  Enrollment enrollment,
                                  Set<StudentQuality.Conflict> qualityConflicts)

      Description copied from interface: `StudentWeights`
      Return weight of the given enrollment
      Specified by:
        `getWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `enrollment` - given enrollment
        `qualityConflicts` - student quality conflicts
      Returns:
        weight (higher weight means better value)

    - #### getStudentQualityConflictWeight

          public double getStudentQualityConflictWeight(Assignment<Request,Enrollment> assignment,
                                                        Enrollment enrollment,
                                                        StudentQuality.Conflict conflict)

      Description copied from interface: `StudentWeights`
      Return weight of a student quality conflict
      Specified by:
        `getStudentQualityConflictWeight` in interface `StudentWeights`
      Parameters:
        `assignment` - current assignment
        `enrollment` - enrollment in question
        `conflict` - student quality conflict
      Returns:
        weight of the conflict